<?php
function a8mngr_install(){
	global $wpdb;
	$table_name = $wpdb->prefix.'a8mngr';
	if($wpdb->get_var("show tables like '$table_name'") != $table_name){
		$sql = "CREATE TABLE ".$table_name." (
			name varchar(64),
			category varchar(64) NOT NULL,
			source text NOT NULL,
			insert_timestamp timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
			id int NOT NULL AUTO_INCREMENT,
			UNIQUE KEY id (id)
		) CHARACTER SET 'utf8';";
		require_once(ABSPATH.'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
}
function a8mngr_uninstall(){
	global $wpdb;
	$table_name = $wpdb->prefix.'a8mngr';
	$wpdb->query("DROP TABLE IF EXISTS {$table_name}");
}



function a8mngr_admin($admin_function){
	require_once(dirname(__FILE__).'/wp-A8-manager-admin.php');
	$plugin_page = add_options_page('WP A8 Manager', 'WP A8 Manager', 8, 'WP-A8-Manager', 'a8mngr_options_page');
	add_action('admin_head-'.$plugin_page, 'a8mngr_admin_style');
}
function a8mngr_admin_style(){
echo <<<str
<style type="text/css">
	table.form-table td {
		vertical-align:top;
	}
	#tags {
		margin-top:10px;
		padding:10px;
		border:1px solid #ddd;
		background-color:#eee;
	}
	#tags span {
		margin:5px;
		padding:2px 5px;
		border:1px solid #da2;
		background-color:#fc4;
		cursor:pointer
	}
	#tags span:hover {
		border:1px solid #b80;
		background-color:#da2;
	}

	ul#tag_list{
		border:1px solid #bbb;
		background-color:#ececec;
		overflow:hidden;
	}
	ul#tag_list li {
		float:left;
		margin:0 5px;
		padding:5px;
		border-left:1px solid #c3c3c3;
		border-right:1px solid #c3c3c3;
		cursor:pointer;
	}
	ul#tag_list li.selected, ul#tag_list li:hover {
		background-color:#cecece;
	}

	div.tag_contents {}
	div.tag_contents td {
		border:1px solid #bbb;
		vertical-align:middle;
	}
	div.tag_contents td.contents_td {
		width:700px;
	}
	div.tag_contents td h3 {
		background-color:#eee;
		margin:5px 0;
	}
	div.tag_contents td h3 span.id {
		font-size:123.1%;
		color:#d74;
	}
	div.tag_contents td h3 span.time {
		font-weight:normal;
		font-size:85%;
		color:#777;
	}
	div.tag_contents td p.submit {
		padding:5px 0;
		text-align:center;
	}
</style>
str;
}



function a8ads($tag_or_id, $num = 1, $html = '', $sort_type = 'random'){
	global $wpdb;
	$table_name = $wpdb->prefix.'a8mngr';

	if($sort_type === 'recent') {
		$sort_sql = ' insert_timestamp DESC ';
	} else {
		$sort_sql = ' RAND() ';
	}

	$start_tag = ($html !== '')?'<'.$html.'>':'';
	$end_tag = ($html !== '')?'</'.$html.'>':'';

	if($tag_or_id === NULL || $tag_or_id === '' || is_numeric($num) === false) return false;
	$where_sql = '';
	if(is_array($tag_or_id) === true){
		$str_check = array_map("is_string", $tag_or_id);
		$num_check = array_map("is_numeric", $tag_or_id);
		if(in_array(false, $str_check) === false) {
			foreach($tag_or_id as $v){
				$where_sql .= " category = '".$v."' OR ";
			}
		} elseif(in_array(false, $num_check) === false) {
			foreach($tag_or_id as $v){
				$where_sql .= " id = {$v} OR ";
			}
		} else {
			return false;
		}
		$where_sql = substr($where_sql, 0, -3);
	} else {
		if(is_string($tag_or_id) === true){
			$where_sql .= " category = '".$tag_or_id."' ";
		} elseif(is_numeric($tag_or_id) === true) {
			$where_sql .= " id = {$tag_or_id} ";
		} else {
			return false;
		}
	}

	$data_array = $wpdb->get_results("SELECT source FROM {$table_name} WHERE {$where_sql} ORDER BY {$sort_sql} LIMIT {$num};");
	foreach($data_array as $k => $v){
		echo $start_tag.stripslashes($v->source).$end_tag."\n";
	}
}



