<?php
function a8mngr_options_page() {
	add_action('login_head', 'a8mngr_admin_style');

	global $wpdb;
	$table_name = $wpdb->prefix.'a8mngr';
	$error_flag = false;
	if(isset($_POST['submit']) === true || isset($_POST['delete']) === true){
		if(isset($_POST['submit']) === true){
			if(strpos($_POST['category'], '"') !== false || strpos($_POST['category'], '"') !== false || is_numeric($_POST['category']) == true) $error_flag = true;
			if($error_flag !== true){
				$wpdb->query($wpdb->prepare("INSERT INTO {$table_name} (name, category, source) VALUES ('%s', '%s', '%s')", $_POST['name'], $_POST['category'], $_POST['source']));
			}
		} elseif(isset($_POST['delete']) === true) {
			$wpdb->query($wpdb->prepare("DELETE FROM {$table_name} WHERE id = %d", $_POST['id']));
		}
		
		if($error_flag === true){
			echo '<div class="error"><p><strong>カテゴリーの入力に誤りがあります。</strong></p></div>';
			$error_str = '<div class="error"><p><strong>カテゴリーの名称に[シングルクォーテーション]、[ダブルクォーテーション]、[数字のみ]は使用しないで下さい。</strong></p></div>';
		} else {
			echo '<div class="updated"><p><strong>更新しました！</strong></p></div>';
		}
	}

	$category_array = $wpdb->get_results("SELECT DISTINCT category FROM {$table_name} ORDER BY category;");
	$data_array = array();
	foreach($category_array as $v){
		$data_array[$v->category] = $wpdb->get_results("SELECT * FROM {$table_name} WHERE category='{$v->category}';", ARRAY_A);
	}
?>

<div class="wrap">
	<h2>広告の投稿</h2>
	<form action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>" method="post">
		<table class="form-table">
			<tr>
				<th>会社名</th>
				<td>
					<input type="text" name="name" value="" style="padding:5px;width:90%"/>
				</td>
			</tr>
			<tr>
				<th>カテゴリー <span style="font-size:85%;color:#c00">※必須</span><span style="font-size:85%;color:#999;display:block">※[シングルクォーテーション]、[ダブルクォーテーション]、[数字のみ]は使用しないで下さい。</span></th>
				<td>
					<?php if(isset($error_str) === true) echo $error_str; ?>
					<input type="text" name="category" value="" style="padding:5px;width:90%" />
	<?php if(count($category_array) !== 0){ ?>
					<div id="tags">
		<?php foreach($category_array as $v){ ?>
						<span><?php echo htmlspecialchars($v->category, ENT_QUOTES); ?></span>
		<?php } ?>
					</div>
	<?php } ?>
				</td>
			</tr>
			<tr>
				<th>HTMLソース <span style="font-size:85%;color:#c00">※必須</span><span style="font-size:85%;color:#999;display:block">※A8.netの広告タグをそのまま貼り付けてください。</span></th>
				<td>
					<textarea name="source" rows="4" cols="80" style="padding:5px;width:90%;height:120px"></textarea>
				</td>
			</tr>
			<tr>
				<td colspan="2" style="text-align:center"><p class="submit">
					<input type="submit" name="submit" value="送信する" />
				</p></td>
			</tr>
		</table>
	</form>

<?php
	if(count($data_array) !== 0){
?>
	<hr />

	<h2>広告の確認と削除</h2>
	<div>
		<ul id="tag_list">
	<?php foreach($data_array as $k => $v){ ?>
			<li><?php echo htmlspecialchars($k, ENT_QUOTES); ?></li>
	<?php } ?>
		</ul>
	<?php foreach($data_array as $key => $val){ ?>
		<div id="t_<?php echo htmlspecialchars($key, ENT_QUOTES); ?>" class="tag_contents">
			<table class="form-table">
		<?php foreach($val as $k => $v){ ?>
				<form action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>" method="post">
					<tr>
						<td class="contents_td">
							<h3>【ID：<span class="id"><?php echo $v['id']; ?></span>】<?php if($v['name'] !== NULL) echo htmlspecialchars($v['name'], ENT_QUOTES); ?> <span class="time">[<?php echo $v['insert_timestamp']; ?>]</span></h3>
							<?php echo stripslashes($v['source']); ?>
						</td>
						<td><p class="submit">
							<input type="hidden" name="id" value="<?php echo $v['id']; ?>" />
							<input type="submit" name="delete" value="削除する" onclick="return confirm('削除したデータは元に戻せません。本当にこの情報を削除しますか？')" />
						</p></td>
					</tr>
				</form>
		<?php } ?>
			</table>
		</div>
	<?php } ?>
	</div>
</div>

<script type="text/javascript">
jQuery(function(){
	jQuery('#tags').css('display', 'none');
	jQuery('div.tag_contents').css('display', 'none');

	jQuery('input[name=category]').click(function(){
		jQuery('#tags').fadeIn('fast');
	});
	jQuery('#tags span').click(function(){
		var s = jQuery(this).html();
		jQuery(this).parent().prev('input').val(s).next('div').fadeOut('fast');
	});
	jQuery('input:not(input[name=category]), textarea').click(function(){
		jQuery('#tags').fadeOut('fast');
	});

	jQuery('#tag_list li').click(function(){
		var t = '#t_' + jQuery(this).html();
		jQuery('div.tag_contents').css('display', 'none');
		jQuery(t).fadeIn('fast');

		jQuery('#tag_list li').removeClass('selected');
		jQuery(this).addClass('selected');
	});
})
</script> 
<?php
	}
}